import{s as Je,n as Ve,o as Ne}from"../chunks/scheduler.9680c161.js";import{S as Re,i as We,g as l,s as n,r as E,A as Be,h as o,f as i,c as s,j as Ae,u as S,x as r,k as U,y as Fe,a,v as D,d as z,t as A,w as J}from"../chunks/index.38d74ee1.js";import{H as V,E as Ke}from"../chunks/EditOnGithub.1c840068.js";function Qe(ke){let u,W,N,B,g,F,h,K,w,be="Guidance is a feature that allows users to constrain the generation of a large language model with a specified grammar. This feature is particularly useful when you want to generate text that follows a specific structure or uses a specific set of words or produce output in a specific format.",Q,v,X,x,Te="Guidance can be in many ways and the community is always finding new ways to use it. Here are some examples of how you can use guidance:",Y,$,_e="Technically, guidance can be used to generate:",Z,k,Ce="<li>a specific JSON object</li> <li>a function signature</li> <li>typed output like a list of integers</li>",ee,b,ye="However these use cases can span a wide range of applications, such as:",te,T,He="<li>extracting structured data from unstructured text</li> <li>summarizing text into a specific format</li> <li>limit output to specific classes of words (act as a LLM powered classifier)</li> <li>generate the input to specific APIs or services</li> <li>provide reliable and consistent output for downstream tasks</li> <li>extract data from multimodal inputs</li>",ie,_,ae,C,Le="Diving into the details, guidance is enabled by including a grammar with a generation request that is compiled, and used to modify the chosen tokens.",ne,y,Me="This process can be broken down into the following steps:",se,H,Pe="<li>A request is sent to the backend, it is processed and placed in batch. Processing includes compiling the grammar into a finite state machine and a grammar state.</li>",le,c,Ge='<img class="block dark:hidden" src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/tgi/request-to-batch.gif"/> <img class="hidden dark:block" src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/tgi/request-to-batch-dark.gif"/>',oe,m,je="<li><p>The model does a forward pass over the batch. This returns probabilities for each token in the vocabulary for each request in the batch.</p></li> <li><p>The process of choosing one of those tokens is called <code>sampling</code>. The model samples from the distribution of probabilities to choose the next token. In TGI all of the steps before sampling are called <code>processor</code>. Grammars are applied as a processor that masks out tokens that are not allowed by the grammar.</p></li>",re,d,qe='<img class="block dark:hidden" src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/tgi/logit-grammar-mask.gif"/> <img class="hidden dark:block" src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/tgi/logit-grammar-mask-dark.gif"/>',ue,f,Ie="<li>The grammar mask is applied and the model samples from the remaining tokens. Once a token is chosen, we update the grammar state with the new token, to prepare it for the next pass.</li>",ce,p,Oe='<img class="block dark:hidden" src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/tgi/sample-logits.gif"/> <img class="hidden dark:block" src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/tgi/sample-logits-dark.gif"/>',me,L,de,M,Ee="There are two main ways to use guidance; you can either use the <code>/generate</code> endpoint with a grammar or use the <code>/chat/completion</code> endpoint with tools.",fe,P,Se="Under the hood tools are a special case of grammars that allows the model to choose one or none of the provided tools.",pe,G,Ue='Please refer to <a href="../basic_tutorials/using_guidance">using guidance</a> for more examples and details on how to use guidance in Python, JavaScript, and cURL.',ge,j,he,q,De="Depending on how you are using guidance, you may want to make use of different features. Here are some tips to get the most out of guidance:",we,I,ze="<li>If you are using the <code>/generate</code> with a <code>grammar</code> it is recommended to include the grammar in the prompt prefixed by something like <code>Please use the following JSON schema to generate the output:</code>. This will help the model understand the context of the grammar and generate the output accordingly.</li> <li>If you are getting a response with many repeated tokens, please use the <code>frequency_penalty</code> or <code>repetition_penalty</code> to reduce the number of repeated tokens in the output.</li>",ve,O,xe,R,$e;return g=new V({props:{title:"Guidance",local:"guidance",headingTag:"h1"}}),h=new V({props:{title:"What is Guidance?",local:"what-is-guidance",headingTag:"h2"}}),v=new V({props:{title:"How is it used?",local:"how-is-it-used",headingTag:"h2"}}),_=new V({props:{title:"How it works?",local:"how-it-works",headingTag:"h2"}}),L=new V({props:{title:"How to use Guidance?",local:"how-to-use-guidance",headingTag:"h2"}}),j=new V({props:{title:"Getting the most out of guidance",local:"getting-the-most-out-of-guidance",headingTag:"h3"}}),O=new Ke({props:{source:"https://github.com/huggingface/text-generation-inference/blob/main/docs/source/conceptual/guidance.md"}}),{c(){u=l("meta"),W=n(),N=l("p"),B=n(),E(g.$$.fragment),F=n(),E(h.$$.fragment),K=n(),w=l("p"),w.textContent=be,Q=n(),E(v.$$.fragment),X=n(),x=l("p"),x.textContent=Te,Y=n(),$=l("p"),$.textContent=_e,Z=n(),k=l("ul"),k.innerHTML=Ce,ee=n(),b=l("p"),b.textContent=ye,te=n(),T=l("ul"),T.innerHTML=He,ie=n(),E(_.$$.fragment),ae=n(),C=l("p"),C.textContent=Le,ne=n(),y=l("p"),y.textContent=Me,se=n(),H=l("ol"),H.innerHTML=Pe,le=n(),c=l("div"),c.innerHTML=Ge,oe=n(),m=l("ol"),m.innerHTML=je,re=n(),d=l("div"),d.innerHTML=qe,ue=n(),f=l("ol"),f.innerHTML=Ie,ce=n(),p=l("div"),p.innerHTML=Oe,me=n(),E(L.$$.fragment),de=n(),M=l("p"),M.innerHTML=Ee,fe=n(),P=l("p"),P.textContent=Se,pe=n(),G=l("p"),G.innerHTML=Ue,ge=n(),E(j.$$.fragment),he=n(),q=l("p"),q.textContent=De,we=n(),I=l("ul"),I.innerHTML=ze,ve=n(),E(O.$$.fragment),xe=n(),R=l("p"),this.h()},l(e){const t=Be("svelte-u9bgzb",document.head);u=o(t,"META",{name:!0,content:!0}),t.forEach(i),W=s(e),N=o(e,"P",{}),Ae(N).forEach(i),B=s(e),S(g.$$.fragment,e),F=s(e),S(h.$$.fragment,e),K=s(e),w=o(e,"P",{"data-svelte-h":!0}),r(w)!=="svelte-416wd"&&(w.textContent=be),Q=s(e),S(v.$$.fragment,e),X=s(e),x=o(e,"P",{"data-svelte-h":!0}),r(x)!=="svelte-1p4ajk9"&&(x.textContent=Te),Y=s(e),$=o(e,"P",{"data-svelte-h":!0}),r($)!=="svelte-15e6bdk"&&($.textContent=_e),Z=s(e),k=o(e,"UL",{"data-svelte-h":!0}),r(k)!=="svelte-u2jqwx"&&(k.innerHTML=Ce),ee=s(e),b=o(e,"P",{"data-svelte-h":!0}),r(b)!=="svelte-kleddr"&&(b.textContent=ye),te=s(e),T=o(e,"UL",{"data-svelte-h":!0}),r(T)!=="svelte-12o2itu"&&(T.innerHTML=He),ie=s(e),S(_.$$.fragment,e),ae=s(e),C=o(e,"P",{"data-svelte-h":!0}),r(C)!=="svelte-1kgb64f"&&(C.textContent=Le),ne=s(e),y=o(e,"P",{"data-svelte-h":!0}),r(y)!=="svelte-162ogxq"&&(y.textContent=Me),se=s(e),H=o(e,"OL",{"data-svelte-h":!0}),r(H)!=="svelte-18gz4cn"&&(H.innerHTML=Pe),le=s(e),c=o(e,"DIV",{class:!0,"data-svelte-h":!0}),r(c)!=="svelte-1al099f"&&(c.innerHTML=Ge),oe=s(e),m=o(e,"OL",{start:!0,"data-svelte-h":!0}),r(m)!=="svelte-1c0rr5h"&&(m.innerHTML=je),re=s(e),d=o(e,"DIV",{class:!0,"data-svelte-h":!0}),r(d)!=="svelte-1kjmamn"&&(d.innerHTML=qe),ue=s(e),f=o(e,"OL",{start:!0,"data-svelte-h":!0}),r(f)!=="svelte-4wrhje"&&(f.innerHTML=Ie),ce=s(e),p=o(e,"DIV",{class:!0,"data-svelte-h":!0}),r(p)!=="svelte-17kexjh"&&(p.innerHTML=Oe),me=s(e),S(L.$$.fragment,e),de=s(e),M=o(e,"P",{"data-svelte-h":!0}),r(M)!=="svelte-1vaei5o"&&(M.innerHTML=Ee),fe=s(e),P=o(e,"P",{"data-svelte-h":!0}),r(P)!=="svelte-1hnurd"&&(P.textContent=Se),pe=s(e),G=o(e,"P",{"data-svelte-h":!0}),r(G)!=="svelte-1dp6uf9"&&(G.innerHTML=Ue),ge=s(e),S(j.$$.fragment,e),he=s(e),q=o(e,"P",{"data-svelte-h":!0}),r(q)!=="svelte-p5xgv9"&&(q.textContent=De),we=s(e),I=o(e,"UL",{"data-svelte-h":!0}),r(I)!=="svelte-15d3zad"&&(I.innerHTML=ze),ve=s(e),S(O.$$.fragment,e),xe=s(e),R=o(e,"P",{}),Ae(R).forEach(i),this.h()},h(){U(u,"name","hf:doc:metadata"),U(u,"content",Xe),U(c,"class","flex justify-center"),U(m,"start","2"),U(d,"class","flex justify-center"),U(f,"start","4"),U(p,"class","flex justify-center")},m(e,t){Fe(document.head,u),a(e,W,t),a(e,N,t),a(e,B,t),D(g,e,t),a(e,F,t),D(h,e,t),a(e,K,t),a(e,w,t),a(e,Q,t),D(v,e,t),a(e,X,t),a(e,x,t),a(e,Y,t),a(e,$,t),a(e,Z,t),a(e,k,t),a(e,ee,t),a(e,b,t),a(e,te,t),a(e,T,t),a(e,ie,t),D(_,e,t),a(e,ae,t),a(e,C,t),a(e,ne,t),a(e,y,t),a(e,se,t),a(e,H,t),a(e,le,t),a(e,c,t),a(e,oe,t),a(e,m,t),a(e,re,t),a(e,d,t),a(e,ue,t),a(e,f,t),a(e,ce,t),a(e,p,t),a(e,me,t),D(L,e,t),a(e,de,t),a(e,M,t),a(e,fe,t),a(e,P,t),a(e,pe,t),a(e,G,t),a(e,ge,t),D(j,e,t),a(e,he,t),a(e,q,t),a(e,we,t),a(e,I,t),a(e,ve,t),D(O,e,t),a(e,xe,t),a(e,R,t),$e=!0},p:Ve,i(e){$e||(z(g.$$.fragment,e),z(h.$$.fragment,e),z(v.$$.fragment,e),z(_.$$.fragment,e),z(L.$$.fragment,e),z(j.$$.fragment,e),z(O.$$.fragment,e),$e=!0)},o(e){A(g.$$.fragment,e),A(h.$$.fragment,e),A(v.$$.fragment,e),A(_.$$.fragment,e),A(L.$$.fragment,e),A(j.$$.fragment,e),A(O.$$.fragment,e),$e=!1},d(e){e&&(i(W),i(N),i(B),i(F),i(K),i(w),i(Q),i(X),i(x),i(Y),i($),i(Z),i(k),i(ee),i(b),i(te),i(T),i(ie),i(ae),i(C),i(ne),i(y),i(se),i(H),i(le),i(c),i(oe),i(m),i(re),i(d),i(ue),i(f),i(ce),i(p),i(me),i(de),i(M),i(fe),i(P),i(pe),i(G),i(ge),i(he),i(q),i(we),i(I),i(ve),i(xe),i(R)),i(u),J(g,e),J(h,e),J(v,e),J(_,e),J(L,e),J(j,e),J(O,e)}}}const Xe='{"title":"Guidance","local":"guidance","sections":[{"title":"What is Guidance?","local":"what-is-guidance","sections":[],"depth":2},{"title":"How is it used?","local":"how-is-it-used","sections":[],"depth":2},{"title":"How it works?","local":"how-it-works","sections":[],"depth":2},{"title":"How to use Guidance?","local":"how-to-use-guidance","sections":[{"title":"Getting the most out of guidance","local":"getting-the-most-out-of-guidance","sections":[],"depth":3}],"depth":2}],"depth":1}';function Ye(ke){return Ne(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class it extends Re{constructor(u){super(),We(this,u,Ye,Qe,Je,{})}}export{it as component};
